/*           TrackIR-, 
  registry entry     NPClient.dll ( 
    ,    dll-   .


REGEDIT4

[HKEY_CURRENT_USER\SOFTWARE\NaturalPoint\NATURALPOINT\NPClient Location]
"Path"="D:\\Program Files\\1C\\fb\\NP\\Debug" 


*/

#include <windows.h>
#include <commctrl.h>
#include <limits.h>
#include "resource.h"

#ifdef TRACING
#include <stdio.h>
FILE *flog;
void wlog(char *str, ...)
{
    va_list arg_ptr;

    va_start(arg_ptr, str);

    if(!flog) flog = fopen("d:\\flog.log", "w");

    vfprintf(flog, str, arg_ptr);
    fflush(flog);

    va_end(arg_ptr);
}
#else
void wlog(char *str, ...) {}
#endif

#pragma pack(push)
#pragma pack(1)
struct data {
	short hbz1;	//0	  (  )
	int counter;	//2	  .  NP_GetData  
			//	         
	short hbz2;	//4	  (  )
	float coord_1;	//8	  (  )
	float coord_2;	//12	   (-16000...+16000)
	float coord_3;	//16	   (-16000...+16000)
			//         ,   +16000 
			//    .
};
#pragma pack(pop)

//      ,    .

int __stdcall NP_RegisterWindowHandle(int handle)//	success == 0
{wlog("NP_RegisterWindowHandle\n");
    return 0;    }

int __stdcall NP_UnregisterWindowHandle()
{wlog("NP_UnregisterWindowHandle\n");
    return 0;    }

int __stdcall NP_RegisterProgramProfileID(int ID)
{wlog("NP_RegisterProgramProfileID\n");
    return 0;    }

int __stdcall NP_QueryVersion(void *version)//	success == 0
{
    wlog("NP_QueryVersion\n");
    return 0;
}
int __stdcall NP_RequestData(int v)	// v == 7
{wlog("NP_RequestData\n");
    return 0;    }

int __stdcall NP_StartCursor(void)
{wlog("NP_StartCursor\n");
    return 0;    }

int __stdcall NP_StopCursor(void)//			success == 0
{wlog("NP_StopCursor\n");
    return 0;    }
int __stdcall NP_StartDataTransmission(void)//		success == 0
{wlog("NP_StartDataTransmission\n");
    return 0;    }
int __stdcall NP_StopDataTransmission(void)
{wlog("NP_StopDataTransmission\n");
    return 0;    }

HINSTANCE inst = NULL;
HWND dialog = NULL;
HANDLE hHook;
INITCOMMONCONTROLSEX icex;


//      

int __stdcall NP_GetData(struct data *data)//			success == 0
{
    static int counter;
    int a = SendMessage(GetDlgItem(dialog, IDC_SLIDER1), TBM_GETPOS, 0, 0); 
    int b = SendMessage(GetDlgItem(dialog, IDC_SLIDER2), TBM_GETPOS, 0, 0); 
    int c = SendMessage(GetDlgItem(dialog, IDC_SLIDER3), TBM_GETPOS, 0, 0); 
    wlog("GetData:");
    data->counter = counter++;
    data->coord_1 = ((float)a);
    data->coord_2 = ((float)b);
    data->coord_3 = ((float)c);
    wlog("%d,%d,%d\n",a,b,c);
    return 0;
}




//      .


INT_PTR CALLBACK DialogProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch(uMsg)
    {
     case WM_INITDIALOG:
         return TRUE;
    case WM_CLOSE:
	return FALSE;
    case WM_ACTIVATEAPP:
	return FALSE;
     case WM_DESTROY:
         return FALSE;
    }
 return FALSE;
}

BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
    if (!inst)
    {
	inst = hinstDLL;
	
	// Ensure that the common control DLL is loaded. 
	icex.dwSize = sizeof(INITCOMMONCONTROLSEX);
	icex.dwICC  = ICC_BAR_CLASSES;
	InitCommonControlsEx(&icex);
	
	dialog = CreateDialog(inst, MAKEINTRESOURCE(IDD_DIALOG1), NULL, DialogProc );
	if(!dialog)
	    MessageBox(NULL, "Can't create dialog", "TrackIR", MB_OK);
	ShowWindow(dialog, SW_SHOW);
	SendMessage(GetDlgItem(dialog, IDC_SLIDER1), TBM_SETRANGE, (WPARAM) TRUE, (LPARAM) MAKELONG(-30000, 30000)); 
	SendMessage(GetDlgItem(dialog, IDC_SLIDER2), TBM_SETRANGE, (WPARAM) TRUE, (LPARAM) MAKELONG(-30000, 30000)); 
	SendMessage(GetDlgItem(dialog, IDC_SLIDER3), TBM_SETRANGE, (WPARAM) TRUE, (LPARAM) MAKELONG(-30000, 30000)); 
	
	SendMessage(GetDlgItem(dialog, IDC_SLIDER1), TBM_SETPOS, (WPARAM) TRUE, (LPARAM) 0); 
	SendMessage(GetDlgItem(dialog, IDC_SLIDER2), TBM_SETPOS, (WPARAM) TRUE, (LPARAM) 0); 
	SendMessage(GetDlgItem(dialog, IDC_SLIDER3), TBM_SETPOS, (WPARAM) TRUE, (LPARAM) 0); 
	
    }
    return TRUE;
}
